var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/account-provider/is-complete-handler.lambda.ts
var is_complete_handler_lambda_exports = {};
__export(is_complete_handler_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(is_complete_handler_lambda_exports);
var AWS = __toESM(require("aws-sdk"));
var organizationsClient;
async function handler(event) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
  console.log(`Request of type ${event.RequestType} received`);
  if (!organizationsClient) {
    organizationsClient = new AWS.Organizations({ region: "us-east-1" });
  }
  console.log("Payload: %j", event);
  let accountId;
  if (event.RequestType == "Create" || isLegacyPhysicalResourceId(event)) {
    const response2 = await organizationsClient.describeCreateAccountStatus({
      CreateAccountRequestId: isLegacyPhysicalResourceId(event) ? event.PhysicalResourceId : (_a = event.Data) == null ? void 0 : _a.CreateAccountStatusId
    }).promise();
    if (((_b = response2.CreateAccountStatus) == null ? void 0 : _b.State) == "IN_PROGRESS") {
      return { IsComplete: false, Data: {} };
    }
    if (((_c = response2.CreateAccountStatus) == null ? void 0 : _c.State) == "FAILED") {
      throw new Error(`Failed ${event.RequestType} Account ${(_d = response2.CreateAccountStatus) == null ? void 0 : _d.AccountName}, reason: ${(_e = response2 == null ? void 0 : response2.CreateAccountStatus) == null ? void 0 : _e.FailureReason}`);
    }
    accountId = (_f = response2.CreateAccountStatus) == null ? void 0 : _f.AccountId;
  } else {
    accountId = event.PhysicalResourceId;
  }
  const response = await organizationsClient.describeAccount({ AccountId: accountId }).promise();
  if (event.RequestType == "Create" || event.RequestType == "Update") {
    await move(organizationsClient, accountId, (_g = event.ResourceProperties) == null ? void 0 : _g.ParentId);
  }
  if (event.RequestType == "Delete" && ((_h = event.ResourceProperties) == null ? void 0 : _h.RemovalPolicy) == "destroy") {
    const root = await findRoot(organizationsClient);
    await move(organizationsClient, accountId, root.Id);
  }
  return {
    IsComplete: true,
    PhysicalResourceId: accountId,
    Data: __spreadProps(__spreadValues(__spreadValues({}, event.ResourceProperties), event.Data), {
      AccountId: accountId,
      AccountArn: (_i = response.Account) == null ? void 0 : _i.Arn,
      AccountName: (_j = response.Account) == null ? void 0 : _j.Name,
      Email: (_k = response.Account) == null ? void 0 : _k.Email
    })
  };
}
var findCurrentParent = async (client, id) => {
  var _a;
  const response = await client.listParents({
    ChildId: id
  }).promise();
  if ((_a = response.Parents) == null ? void 0 : _a.length) {
    return response.Parents[0];
  }
  throw new Error(`Could not find parent for id '${id}'`);
};
var findRoot = async (client) => {
  var _a;
  const response = await client.listRoots().promise();
  if ((_a = response.Roots) == null ? void 0 : _a.length) {
    return response.Roots[0];
  }
  throw new Error(`Could not find root`);
};
var move = async (client, accountId, destinationParentId) => {
  if (!destinationParentId) {
    return;
  }
  const currentParent = await findCurrentParent(organizationsClient, accountId);
  if (destinationParentId == currentParent.Id) {
    return;
  }
  await client.moveAccount({
    AccountId: accountId,
    SourceParentId: currentParent.Id,
    DestinationParentId: destinationParentId
  }).promise();
};
var isLegacyPhysicalResourceId = (event) => {
  return !/\d{12}/.test(event.PhysicalResourceId);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
//# sourceMappingURL=index.js.map
