var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/account-provider/on-event-handler.lambda.ts
var on_event_handler_lambda_exports = {};
__export(on_event_handler_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(on_event_handler_lambda_exports);
var import_aws_sdk = require("aws-sdk");
var organizationsClient;
async function handler(event) {
  var _a;
  console.log(`Request of type ${event.RequestType} received`);
  if (!organizationsClient) {
    organizationsClient = new import_aws_sdk.Organizations({ region: "us-east-1" });
  }
  console.log("Payload: %j", event);
  const { Email, AccountName, RoleName, IamUserAccessToBilling, ImportOnDuplicate } = event.ResourceProperties;
  if (event.RequestType == "Create" && ImportOnDuplicate == "true") {
    const account = await findAccountByEmail(organizationsClient, Email);
    if (account) {
      return {
        PhysicalResourceId: account.Id,
        Data: __spreadProps(__spreadValues({}, event.ResourceProperties), { AccountId: account.Id })
      };
    }
  }
  if (event.RequestType == "Create") {
    const response = await organizationsClient.createAccount({
      Email,
      AccountName,
      RoleName,
      IamUserAccessToBilling
    }).promise();
    console.log("Creating account: %j", response);
    return {
      Data: __spreadProps(__spreadValues({}, event.ResourceProperties), { CreateAccountStatusId: (_a = response.CreateAccountStatus) == null ? void 0 : _a.Id })
    };
  }
  return __spreadProps(__spreadValues({}, event), {
    Data: __spreadValues({}, event.ResourceProperties)
  });
}
var findAccountByEmail = async (client, email) => {
  let response = await client.listAccounts().promise();
  for (const account of response.Accounts ?? []) {
    if (account.Email == email) {
      return account;
    }
  }
  while (response.NextToken) {
    response = await client.listAccounts().promise();
    for (const account of response.Accounts ?? []) {
      if (account.Email == email) {
        return account;
      }
    }
  }
  return void 0;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
//# sourceMappingURL=index.js.map
